﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Encodings.VariableVector {
  [Item("UniformOnePositionInConditionManipulator", "Description missing")]
  [StorableClass]
  public class UniformOnePositionInConditionManipulator : VariableVectorManipulator {

    #region Parameter Properties
    #endregion

    [StorableConstructor]
    protected UniformOnePositionInConditionManipulator(bool deserializing) : base(deserializing) { }
    protected UniformOnePositionInConditionManipulator(UniformOnePositionInConditionManipulator original, Cloner cloner)
      : base(original, cloner) {
    }
    public UniformOnePositionInConditionManipulator()
      : base() {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new UniformOnePositionInConditionManipulator(this, cloner);
    }

    protected override VariableVector Manipulate(IRandom random, VariableVectorInput input, VariableVector child) {
      return Manipulate(random, input, child, random.Next(child.Condition.VirtualLength));
    }

    public static VariableVector Manipulate(IRandom random, VariableVectorInput input, VariableVector child, int index) {
      VariableVectorCondition condition = child.Condition;
      if (index >= condition.VirtualLength) {
        throw new ArgumentOutOfRangeException();
      }
      var keyEnumerator = condition.Order.GetEnumerator();
      int count = 0;
      keyEnumerator.MoveNext();
      while (count < condition.VirtualLength && count < index && count + condition.VariableDictionary[keyEnumerator.Current].VirtualLength <= index) {
        count += condition.VariableDictionary[keyEnumerator.Current].VirtualLength;
        keyEnumerator.MoveNext();
      }
      condition.VariableDictionary[keyEnumerator.Current].Manipulate(random, input.InputDictionary[keyEnumerator.Current], index - count);
      return child;
    }
  }
}
